"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.event = exports.ticks = exports.tick = void 0;
function tick() {
    return new Promise((resolve) => {
        process.nextTick(() => resolve());
    });
}
exports.tick = tick;
function ticks(amount = 1) {
    if (amount < 1)
        return Promise.resolve();
    const checkNextTick = (resolve) => {
        process.nextTick(() => {
            amount--;
            if (amount)
                checkNextTick(resolve);
            else
                resolve();
        });
    };
    return new Promise(checkNextTick);
}
exports.ticks = ticks;
function event(delegate) {
    return new Promise((resolve) => {
        const handler = (...args) => {
            delegate.remove(handler);
            resolve(args);
        };
        delegate.add(handler);
    });
}
exports.event = event;
